
(* Analyse smantique *)

open Ast

(* Erreurs de typage, localises, et fonction [report] pour les afficher *)

type error

exception Error of loc * error

val report : Format.formatter -> error -> unit

(* Constante rutilise dans compile *)

val tag_multiplier : int

(* Primitives *)

val is_primitive_function : t_function -> bool
val is_primitive_procedure : t_procedure -> bool

(* Fonction de typage d'une unit de compilation *)

val file : p_file -> t_file

